/*
 * 创客等级设定
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserLevelSetController : BaseController
    {
        public UserLevelSetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客等级设定列表

        /// <summary>
        /// 根据条件查询创客等级设定列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserLevelSet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询创客等级设定列表

        /// <summary>
        /// 创客等级设定列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserLevelSet data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //等级名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserLevelSet", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加创客等级设定

        /// <summary>
        /// 增加或修改创客等级设定信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加创客等级设定

        /// <summary>
        /// 增加或修改创客等级设定信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserLevelSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Name", data.Name); //等级名称
            Fields.Add("Details", data.Details); //等级描述
            Fields.Add("UpLevelDays", data.UpLevelDays); //升级天数
            Fields.Add("UpLevelIntegral", data.UpLevelIntegral); //升级需要积分值
            Fields.Add("UpLevelGrowth", data.UpLevelGrowth); //升级需要成长值

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserLevelSet", Fields, 0);
            AddSysLog(Id.ToString(), "UserLevelSet", "add");
            db.SaveChanges();

            UserLevelSet level = db.UserLevelSet.FirstOrDefault(m => m.Id == Id);
            if (level != null)
            {
                RedisDbconn.Instance.Set("UserLevelSet:" + Id, level);
            }
            SetRedis();

            return "success";
        }

        #endregion

        #region 修改创客等级设定

        /// <summary>
        /// 增加或修改创客等级设定信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            UserLevelSet editData = db.UserLevelSet.FirstOrDefault(m => m.Id == Id) ?? new UserLevelSet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客等级设定

        /// <summary>
        /// 增加或修改创客等级设定信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserLevelSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Name", data.Name); //等级名称
            Fields.Add("Details", data.Details); //等级描述
            Fields.Add("UpLevelDays", data.UpLevelDays); //升级天数
            Fields.Add("UpLevelIntegral", data.UpLevelIntegral); //升级需要积分值
            Fields.Add("UpLevelGrowth", data.UpLevelGrowth); //升级需要成长值

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserLevelSet", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserLevelSet", "update");
            db.SaveChanges();

            UserLevelSet level = db.UserLevelSet.FirstOrDefault(m => m.Id == data.Id);
            if (level != null)
            {
                RedisDbconn.Instance.Set("UserLevelSet:" + data.Id, level);
            }
            SetRedis();

            return "success";
        }

        #endregion

        #region 删除创客等级设定信息

        /// <summary>
        /// 删除创客等级设定信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserLevelSet", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("UserLevelSet", id);
            }
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserLevelSet", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserLevelSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserLevelSet", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserLevelSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserLevelSet", Sort, Id);

            AddSysLog(Id.ToString(), "UserLevelSet", "sort");

            SetRedis();
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];
                int UpLevelGrowth = int.Parse(dr["升级需要成长值"].ToString());

                db.UserLevelSet.Add(new UserLevelSet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    UpLevelGrowth = UpLevelGrowth,   //升级需要成长值

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserLevelSet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserLevelSet data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //等级名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserLevelSet", Fields, "Id desc", "False", 1, 20000, "", "UpLevelGrowth", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UpLevelGrowth", "升级需要成长值");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserLevelSet", "ExportExcel");
            return Json(result);
        }

        #endregion



        #region 设置缓存

        private void SetRedis()
        {
            RedisDbconn.Instance.Clear("UserLevelSet");
            List<UserLevelSet> list = db.UserLevelSet.Where(m => m.Status > -1).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            RedisDbconn.Instance.AddList("UserLevelSet", list.ToArray());
        }

        #endregion

    }
}
